<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: Normal.php 2319 2005-04-04 15:23:15Z andrew $
*/

/**
 * @package    MaxMaintenance
 * @subpackage Priority
 * @author     Andrew Hill <andrew@awarez.net>
 */

require_once MAX_PATH . '/lib/max/Maintenance/Priority/AdServer/AdvertisementZoneImpressionAllocation/Common.php';
 
/**
 * The default implementation of {@link Maintenance_Priority_AdServer_AdvertisementZoneImpressionAllocation_Common}
 * distributed with Max.
 */
class Maintenance_Priority_AdServer_AdvertisementZoneImpressionAllocation_Normal extends Maintenance_Priority_AdServer_AdvertisementZoneImpressionAllocation_Common
{
    
    /**
     * The default implementation of 
     * {@link Maintenance_Priority_AdServer_AdvertisementZoneImpressionAllocation_Common::allocateAdvertisementImpressions()}
     * distributed with Max.
     *
     * Required advertisements impressions are allocated in a set order, so that if
     * there are insufficient impressions available in a zone to satisfy the requirements,
     * more "important" advertisements will have impressions allocated first. The order
     * of advertisement "importance" is:
     *
     * - Advertisements in higher level Priority campaigns are allocated their impressions
     *   before advertisements in lower level Priority campaigns.
     * - Advertisements campaigns with an Expiration Date are allocated their impressions
     *   before advertisements in campaigns without an Expiration Date, given the same
     *   campaign Priority level.
     * - Advertisements in campaigns with an earlier (i.e. sooner) Expiration Date are
     *   allocated their impressions before advertisements in campaigns with a later
     *   Expiration Date, given the same campaign Priority level.
     * - Advertisements with a greater number of (non-infinite) required impressions are
     *   allocated their impressions before advertisements with a smaller number of
     *   (non-infinite) required impressions, given the same campaign Priority level,
     *   and the same campaign Expiration Date or the same lack of Expiration Date.
     * 
     * In the above order, required advertisement impressions (obtained from the
     * tmp_ad_required_impression temporary table) are allocated to zones proportionally
     * to the number of remaining (expected) impressions for each possible zone.
     * For example:
     *
     * - If Advertisement 1 requires 10 impressions, and is linked Zone 1 with 10
     *   expected impressions and Zone 2 with 30 expected impressions, the advertisement
     *   would be allocated (10/40)*10=2.5 impressions in Zone 1, and (10/40)*30=7.5
     *   impressions in Zone 2. This would leave Zone 1 with 7.5 impressions, and Zone 2
     *   with 22.5 impressions.
     * - Then, if Adververtisement 2 requires 10 impressions, and is also linked to 
     *   Zone 1 and Zone 2, then the advertisement would be allocated (10/30)*7.5=2.5
     *   impressions in Zone 1, and (10/30)*22.5=7.5 impressions in Zone 2. This would
     *   leave 5 impressions in Zone 1, and 15 impressions in Zone 2.
     * - Then, if Advertisement 3 requires 50 impressions, and is also linked to Zone
     *   1 and Zone 2, then the advertisements would be allocated (50/20)*5=12.5
     *   impressions in Zone 1 (rounded down to 5 impressions, as 12.5 > 5), and
     *   (50/20)*15=37.5 impressions in Zone 2 (rounded down to 15 impressions, as
     *   37.5 > 15). This would leave no available impressions in Zone 1 and 2 for
     *   any further advertisements.
     *
     * Note: Always do the multiplication before the division in the code, to try to 
     * avoid rounding errors.
     *
     * @TODO Needs to be written.
     */
    function allocateAdvertisementImpressions()
    {
    
    }
    
}

?>
