<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: Common.php 2323 2005-04-04 16:52:08Z andrew $
*/

/**
 * @package    MaxMaintenance
 * @subpackage Priority
 * @author     Andrew Hill <andrew@awarez.net>
 */
 
/**
 * An abstract class used to specify the interface for classes that calculate
 * the number of required impressions for non-house campaign advertisements
 * in the next operation interval.
 *
 * @abstract
 */
class Maintenance_Priority_AdServer_RequiredAdvertisementImpression_Common
{
 
    /**
     * A method for calculating the number of required impressions for each active,
     * non-house campaign advertisement in the next operation interval. Upon completion,
     * the advertisement IDs and required impressions should be stored in the
     * tmp_ad_required_impression table.
     */
    function calculateRequiredImpressions() {}
    
}

?>
