<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: all_tests.php 2409 2005-04-07 14:28:24Z andrew $
*/

/**
 * @package    MaxMaintenance
 * @subpackage TestSuite
 * @author     Andrew Hill <andrew@awarez.net>
 */

/**
 * A class for running the Maintenance Engine tests. Designed to be included
 * in a main, project-wide all_tests.php file, or to be run by itself.
 */
class MAX_Maintenance_Tests
{
    
    function run()
    {
        // Setup the testing environment
        if (!defined('MAX_PATH')) {
            include_once '../../../../constants.php';
        }
        include_once MAX_PATH . '/tests/testEnvironment.php';
        $testEnvironment = new testEnvironment();
        $testEnvironment->init(true);
        // Tests require "max_" table prefix
        $prefixBackup = $GLOBALS['_MAX']['CONF']['table']['prefix'];
        $GLOBALS['_MAX']['CONF']['table']['prefix'] = 'max_';
        // Don't use a PEAR_Error handler for Maintenance Statistics tests
        PEAR::pushErrorHandling(null);
        // Run the tests on the Maintenance Engine (Statistics) that DO need a database
        $test = &new GroupTest('Maintenance Engine (Statistics): Data Tests');
        $test->addTestFile(MAX_PATH . '/lib/max/Maintenance/tests/TestOfMaintenance.php');
        $test->addTestFile(MAX_PATH . '/lib/max/Maintenance/tests/TestOfMaintenanceStatistics.php');
        $test->addTestFile(MAX_PATH . '/lib/max/Maintenance/tests/TestOfMaintenanceStatisticsCommon.php');
        $test->addTestFile(MAX_PATH . '/lib/max/Maintenance/tests/TestOfMaintenanceStatisticsAdServer.php');
        $test->addTestFile(MAX_PATH . '/lib/max/Maintenance/tests/TestOfMaintenanceStatisticsTracker.php');
        $test->run(new HtmlReporter());
        // Run the tests on the Maintenance Engine (Priority) that do not need a database
        $test = &new GroupTest('Maintenance Engine (Priority): Base Tests');
        $test->addTestFile(MAX_PATH . '/lib/max/Maintenance/tests/TestOfPriorityAdServerZoneImpressionForecast.php');
        $test->addTestFile(MAX_PATH . '/lib/max/Maintenance/tests/TestOfPriorityAdServerRequiredAdvertisementImpression.php');
        $test->addTestFile(MAX_PATH . '/lib/max/Maintenance/tests/TestOfPriorityAdServerAdvertisementZoneImpressionAllocation.php');
        $test->addTestFile(MAX_PATH . '/lib/max/Maintenance/tests/TestOfPriorityAdServerFilterCompensation.php');
        $test->addTestFile(MAX_PATH . '/lib/max/Maintenance/tests/TestOfPriorityAdServerZoneImpressionForecastCommon.php');
        $test->addTestFile(MAX_PATH . '/lib/max/Maintenance/tests/TestOfPriorityAdServerZoneImpressionForecastNormal.php');
        $test->run(new HtmlReporter());
        // Resore the PEAR_Error handler
        PEAR::popErrorHandling();
        // Restore the table prefix
        $GLOBALS['_MAX']['CONF']['table']['prefix'] = $prefixBackup;
        // Close off the testing environment
        $testEnvironment->deinit();
    }

}

MAX_Maintenance_Tests::run();

?>
