<?php
/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: lib-io.inc.php 2560 2005-04-17 15:34:57Z chris $
*/

/*-------------------------------------------------------*/
/* Register globals                                      */
/*-------------------------------------------------------*/

function phpAds_registerGlobal()
{
    $args = func_get_args();
    while (list(,$key) = each($args)) {
        if (isset($_GET[$key])) {
            $value = $_GET[$key];
        }
        if (isset($_POST[$key])) {
            $value = $_POST[$key];
        }
        if (isset($value)) {
            if (!ini_get('magic_quotes_gpc')) {
                if (!is_array($value)) {
                    $value = addslashes($value);
                } else {
                    $value = phpAds_slashArray($value);
                }
            }
            $GLOBALS[$key] = $value;
            unset($value);
        }
    }
}

// This function will allow the source to be derived from server side parameters, such
// as referer, current location, user agent, domain, etc.
function phpAds_deriveSource ($source, $referer='')
{
    global $matches, $failed;
    $source = trim(urldecode($source));
    if ($source == '{derive}') {
        // Break down the referer...
        if (isset($_SERVER['HTTP_REFERER'])) {
            $referer =& $_SERVER['HTTP_REFERER'];
        }
        if ((is_null($referer)) && isset($_GET['loc'])) {
            $referer =& $_GET['loc'];
        }
        $derivedSource = $referer;
        
        include_once MAX_PATH . '/lib/max/Plugins/Plugins.php';
        $channelDelivery = Max_Plugins::factory('channelDelivery', 'SQLContainer');
        if($channelDelivery !== false) {
            $derivedSource = $channelDelivery->getDerivedSource($referer);
        }
        
        return phpAds_encrypt($derivedSource);
    }
    return phpAds_encrypt($source);
}

/*-------------------------------------------------------*/
/* Recursive add slashes to an array                     */
/*-------------------------------------------------------*/

function phpAds_slashArray ($a)
{
    while (list($k,$v) = each($a)) {
        if (!is_array($v)) {
            $a[$k] = addslashes($v);
        } else {
            $a[$k] = phpAds_slashArray($v);
        }
    }
    reset ($a);
    return ($a);
}

/*-------------------------------------------------------*/
/* Store cookies to be set in a cache                    */
/*-------------------------------------------------------*/

function phpAds_getUniqueUserID($create = true)
{
    $conf = &$GLOBALS['_MAX']['CONF'];
    if (isset($_COOKIE[$conf['var']['viewerId']])) {
        $userid = $_COOKIE[$conf['var']['viewerId']];
    }
    if (!isset($userid)) {
        if ($create) {
            // Create a unique ID.  This is done by combining the web server's address, remote address, and microtime.
            $remote_address = $_SERVER['REMOTE_ADDR'];
            $local_address  = $conf['webpath']['delivery']; // How do I get the IP address of this server?
            // Get the exact time
            list($usec, $sec) = explode(" ", microtime());
            $time = (float) $usec + (float) $sec;
            // Get a random number
            $random = mt_rand(0,999999999);
            $userid = substr(md5($local_address.$time.$remote_address.$random),0,32);  // Need to find a way to generate this...
        } else {
            $userid = null;
        }
    }
    return $userid;
}

/*-------------------------------------------------------*/
/* Store cookies to be set in a cache                    */
/*-------------------------------------------------------*/

function phpAds_setCookie($name, $value, $expire = 0)
{
    global $phpAds_cookieCache;
    if (!isset($phpAds_cookieCache)) {
        $phpAds_cookieCache = array();
    }
    $phpAds_cookieCache[] = array($name, $value, $expire);
}

/*-------------------------------------------------------*/
/* Send all cookies to the browser and clear cache       */
/*-------------------------------------------------------*/

function phpAds_flushCookie ()
{
    $conf = $GLOBALS['_MAX']['CONF'];
    global $phpAds_cookieCache;
    if (isset($phpAds_cookieCache)) {
        // Send P3P headers
        if ($conf['p3p']['policies']) {
            $p3p_header = '';
            if ($conf['p3p']['policyLocation'] != '') {
                $p3p_header .= " policyref=\"".$conf['p3p']['policyLocation']."\"";
            }
            if ($conf['p3p']['policyLocation'] != '' && $conf['p3p']['compactPolicy'] != '') {
                $p3p_header .= ", ";
            }
            if ($conf['p3p']['compactPolicy'] != '') {
                $p3p_header .= " CP=\"".$conf['p3p']['compactPolicy']."\"";
            }
            if ($p3p_header != '') {
                header("P3P: $p3p_header");
            }
        }
        // Set cookies
        while (list($k,$v) = each ($phpAds_cookieCache)) {
            list($name, $value, $expire) = $v;
            setcookie($name, $value, $expire, '/');
        }
        // Clear cache
        $phpAds_cookieCache = array();
    }
}

function phpAds_isClickBlocked($bannerid)
{
    global $log;
    $blockClick = false;
    if ($log == 'no') {
        $blockClick = true;
    } elseif ($conf['logging']['blockAdClicks'] > 0) {
        if (isset($_COOKIE['phpAds_blockClick'][$bannerid])
        && $_COOKIE['phpAds_blockClick'][$bannerid] > time()) {
            $blockClick = true;
        }
    }
    return $blockClick;
}

function phpAds_updateClickBlockTime($bannerid)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    if ($conf['logging']['blockAdClicks'] > 0) {
        phpAds_setCookie("phpAds_blockClick[".$bannerid."]", time() + $conf['logging']['blockAdClicks'],
        time() + $conf['logging']['blockAdClicks'] + 43200);
    }
}

function phpAds_isConversionBlocked($trackerid)
{
    $blockConversion = false;
    if ($conf['logging']['blockTrackerImpressions'] > 0) {
        if (isset($_COOKIE['phpAds_blockConversion'][$trackerid])
        && $_COOKIE['phpAds_blockConversion'][$trackerid] > time()) {
            $blockConversion = true;
        }
    }
    return $blockConversion;
}

function phpAds_updateConversionBlockTime($trackerid)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    if ($conf['logging']['blockTrackerImpressions'] > 0) {
        phpAds_setCookie("phpAds_blockConversion[".$trackerid."]", time() + $conf['logging']['blockTrackerImpressions'],
        time() + $conf['logging']['blockTrackerImpressions'] + 43200);
    }
}

function phpAds_isViewBlocked($bannerid)
{
    $blockView = false;
    if ($conf['logging']['blockAdImpressions'] > 0) {
        if (isset($_COOKIE['phpAds_blockView'][$bannerid])
        && $_COOKIE['phpAds_blockView'][$bannerid] > time()) {
            $blockView = true;
        }
    }
    return $blockView;
}

function phpAds_updateViewBlockTime($bannerid)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    if ($conf['logging']['blockAdImpressions'] > 0) {
        phpAds_setCookie("phpAds_blockView[".$bannerid."]", time() + $conf['logging']['blockAdImpressions'],
        time() + $conf['logging']['blockAdImpressions'] + 43200);
    }
}

function phpAds_updateAdBlockTime($bannerid, $block)
{
    if (($block != '') && ($block != '0')) {
        phpAds_setCookie ($GLOBALS['conf']['var']['blockAd']."[".$bannerid."]", time() + $block, time() + $block + 43200);
    }
}
function phpAds_isAdBlocked($bannerid, $block)
{
    $blocked = false;
    if ($block > 0) {
        if (isset($_COOKIE[$GLOBALS['conf']['var']['blockAd']][$bannerid])
        && (($_COOKIE[$GLOBALS['conf']['var']['blockAd']][$bannerid] + $block) > time())) {
            $blocked = true;
        }
    }
    return $blocked;
}

function phpAds_isAdCapped($bannerid, $capping, $session_capping = 0)
{
    $capped = false;
    if ($capping > 0) {
        if (isset($_COOKIE[$GLOBALS['conf']['var']['capAd']][$bannerid])
        && ($_COOKIE[$GLOBALS['conf']['var']['capAd']][$bannerid] >= $capping)) {
            $capped = true;
        }
    }
    if ($session_capping > 0) {
        if (isset($_COOKIE[$GLOBALS['conf']['var']['sessionCapAd']][$bannerid])
        && ($_COOKIE[$GLOBALS['conf']['var']['sessionCapAd']][$bannerid] >= $session_capping)) {
            $capped = true;
        }
    }
    return $capped;
}

function phpAds_updateAdCapping($bannerid, $capping,  $session_capping = 0)
{
    if (($capping != '') && ($capping != '0')) {
        if (	isset($_COOKIE[$GLOBALS['conf']['var']['capAd']])
        &&  isset($_COOKIE[$GLOBALS['conf']['var']['capAd']][$bannerid])) {
            $newcap = $_COOKIE[$GLOBALS['conf']['var']['capAd']][$bannerid] + 1;
        } else {
            $newcap = 1;
        }
        phpAds_setCookie($GLOBALS['conf']['var']['capAd']."[".$bannerid."]", $newcap, time() + 31536000); // 1 year
    }
    if (($session_capping != '') && ($session_capping != '0')) {
        if (isset($_COOKIE[$GLOBALS['conf']['var']['sessionCapAd']])
        && isset($_COOKIE[$GLOBALS['conf']['var']['sessionCapAd']][$bannerid])) {
            $newcap = $_COOKIE[$GLOBALS['conf']['var']['sessionCapAd']][$bannerid] + 1;
        } else {
            $newcap = 1;
        }
        phpAds_setCookie($GLOBALS['conf']['var']['sessionCapAd']."[".$bannerid."]", $newcap, 0); // session cookie
    }
}

function phpAds_encrypt($string)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $convert = '';
    if (isset($string) && substr($string,1,4) != 'obfs' && $conf['delivery']['obfuscate']) {
        for ($i=0; $i < strlen($string); $i++) {
            $dec = ord(substr($string,$i,1));
            if (strlen($dec) == 2) {
                $dec = 0 . $dec;
            }
            $dec = 324 - $dec;
            $convert .= $dec;
        }
        $convert = '{obfs:' . $convert . '}';
        return ($convert);
    } else {
        return $string;
    }
}

function phpAds_decrypt($string)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $convert = '';
    if (isset($string) && substr($string,1,4) == 'obfs' && $conf['delivery']['obfuscate']) {
        for ($i=6; $i < strlen($string)-1; $i = $i+3) {
            $dec = substr($string,$i,3);
            $dec = 324 - $dec;
            $dec = chr($dec);
            $convert .= $dec;
        }
        return ($convert);
    } else {
        return($string);
    }
}

?>